/*
 * Created on 2004-2-10
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package analysis.gps.server.ejb;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Vector;

import javax.ejb.EJBException;
import javax.ejb.FinderException;
import javax.ejb.CreateException; 
import javax.ejb.RemoveException;
import javax.ejb.SessionBean;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import drasys.or.graph.VertexI;

import analysis.gps.server.routeFinder.RouteFinder;
import analysis.gps.server.routeFinder.RouteFinderHome;

/**
 * @ejb.bean name="GPSBroker"
 *	jndi-name="GPSBrokerBean"
 *	type="Stateless" 
 * 
 *--
 * This is needed for JOnAS.
 * If you are not using JOnAS you can safely remove the tags below.
 * @jonas.bean ejb-name="GPSBroker"
 *	jndi-name="GPSBrokerBean"
 * 
 *--
 **/
public abstract class GPSBrokerBean implements SessionBean {

	
private Route route = new Route();
	
/**
 * @ejb.interface-method
 *	view-type="remote" 
**/
public boolean stopService(Integer id) throws RemoteException{ 

	try{
		Collection all = getGPSClientLocalHome().findAll();
		Iterator it = all.iterator();
		boolean removed = false;
		
		//If the use record exists, remove them and return true;
		while(it.hasNext()){
			GPSClientLocal element = (GPSClientLocal) it.next();

			if(element.getC_id().equals(id)){
				element.remove();
				removed = true;
			}	
		}
		//	If there is no such user, return false;
		if (!removed) {
			throw new RemoteException("No such user");
		}
		return true;
	}
	catch (NamingException e) {
		//e.printStackTrace();
		System.out.println("Naming Exception Occured");
		throw new EJBException("Naming Exception Occured");
	} 
	catch (FinderException e) {
		//e.printStackTrace();
		System.out.println("Finder Exception Occured");
		throw new EJBException("Finder Exception Occured");
	}
	catch (RemoteException e) {
		//e.printStackTrace();
		System.out.println("Remote Exception Occured");
		throw new EJBException("Remote Exception Occured");
	} catch (RemoveException e) {
		//e.printStackTrace();
		System.out.println("Remove Exception Occured");
		throw new EJBException("Remove Exception Occured");
	}
		

}
/**
 * @ejb.interface-method
 *	view-type="remote" 
**/
public Route getNextStep(Integer id) {
	
	int clientId=id.intValue();
	int nextId = 0;
	int currentMid =0;
	Vector path = null;
	boolean valid = false;
	try{
		GPSClientLocal gpsClient = getGPSClientLocalHome().findByPrimaryKey(id);
	
		RouteFinder routeFinder= getRouteFinderHome().create();
		VertexI initialPosition=routeFinder.getInitialPosition();
		VertexI finalPosition=routeFinder.getFinalPosition(gpsClient.getDpos_x());
		System.out.println("inital:"+initialPosition.getIndex());
		System.out.println("inital:"+finalPosition.getIndex());
		if (initialPosition.getIndex()==finalPosition.getIndex()){
			route = new Route();
			route.serverMessage ="You are arrived.";
			return route;
		}
		
		path = routeFinder.findRoute(initialPosition,finalPosition);

	
	// messageID ++;
	// send <ClientID,MessageID,Current PositionX,Current PositionY,DestinationY> to entity Bean.

		Collection all = getGPSClientLocalHome().findAll();
		Iterator it = all.iterator();
		GPSClientLocal returnElement = null;
		GPSClientLocal element = null;

		while(it.hasNext()){
			
			element = (GPSClientLocal) it.next();
			if((element.getId()).intValue() >= nextId){
				nextId = (element.getId()).intValue();
			}
			
			if((element.getC_id().equals(id)) && ((element.getM_id()).intValue() >= currentMid) ){
				returnElement = element;
				currentMid =(element.getM_id()).intValue();
				valid = true;
			}
		}
		
		if (!valid){
			throw new RemoteException("No such user");
		}
		
	
		
		getGPSClientLocalHome().create(new Integer(nextId+1),id,new Integer(currentMid+1), new Integer(initialPosition.getIndex()),returnElement.getDpos_x());
		wrapRoute(new Integer(clientId).toString(),new Integer(currentMid+1).toString(),path);
		return route;
	}
	catch (NamingException e) {
		//e.printStackTrace();
		System.out.println("Naming Exception Occured");
		throw new EJBException("Naming Exception Occured");
	} 
	catch (FinderException e) {
		//e.printStackTrace();
		System.out.println("Finder Exception Occured");
		throw new EJBException("Finder Exception Occured");
	}
	catch (CreateException e) {
		//e.printStackTrace();
		System.out.println("Create Exception Occured");
		throw new EJBException("Create Exception Occured");
	}
	catch (RemoteException e) {
		//e.printStackTrace();
		System.out.println("Remote Exception Occured");
		throw new EJBException("Remote Exception Occured");
	}

	

  
}


/**
*  Wrap information into Route object. 
* 
**/
public void wrapRoute(String clientId, String messageId, Vector path) { 
	
	Context ctx = null; 
	DataSource ds = null; 
	Connection conn = null; 
	PreparedStatement stmt = null;
	ResultSet rs = null;

		//GPSMapLocal mapBean = getGPSMapLocalHome().findByPrimaryKey(new Integer(1));
		route.sessionID = clientId;
		route.messageID = messageId;
		
		Enumeration enum = path.elements();
		route.completeRoute.clear();
		route.completeRoute.addElement( ((VertexI)enum.nextElement()).getValue());
		while(enum.hasMoreElements()){
			enum.nextElement();// Remove Edge //
			route.completeRoute.addElement(((VertexI)enum.nextElement()).getValue());
		}		
				
		route.currentRoadName =(String)route.completeRoute.elementAt(0);
		route.nextRoadName = (String)route.completeRoute.elementAt(1);
		route.serverMessage ="Query completed successfully";
	
}


private analysis.gps.server.ejb.GPSClientLocalHome getGPSClientLocalHome()
throws NamingException {
	return (GPSClientLocalHome) getContext().lookup(
			GPSClientLocalHome.JNDI_NAME);
}
private InitialContext getContext() throws NamingException {
	Hashtable props = new Hashtable();

	props.put(
			InitialContext.INITIAL_CONTEXT_FACTORY,
	"org.jnp.interfaces.NamingContextFactory");
	props.put(InitialContext.PROVIDER_URL, "jnp://127.0.0.1:1099");

	InitialContext initialContext = new InitialContext(props);
	return initialContext;
}
/**
 * @ejb.interface-method
 *	view-type="remote" 
**/
public Route getService(Integer destination) { 
	Vector path= null;
	int nextId =0;
	int nextCid =0;
	int nextMid =0;	
	try{
		
		// Find the route to the destination
		RouteFinder routeFinder= getRouteFinderHome().create();
		
		VertexI finalPosition=routeFinder.getFinalPosition(destination);
		VertexI initialPosition=routeFinder.getInitialPosition();
		
		//initial position cannot be the same as final position.
		while (initialPosition.getIndex() == finalPosition.getIndex()){
			initialPosition=routeFinder.getInitialPosition();
		}
		path = routeFinder.findRoute(initialPosition,finalPosition);
		
		// Create a client id in the client_log table for this new client;
		Collection all = getGPSClientLocalHome().findAll();
		Iterator it = all.iterator();

		while(it.hasNext()){
			GPSClientLocal element = (GPSClientLocal) it.next();
			if((element.getId()).intValue() >= nextId){
				nextId = (element.getId()).intValue();
			}
			if((element.getC_id()).intValue() >= nextCid){
				nextCid = (element.getC_id()).intValue();
			}	
		}
		nextId +=1;
		nextCid+=1;
		nextMid+=1;
		getGPSClientLocalHome().create(new Integer(nextId),new Integer(nextCid),new Integer(nextMid), new Integer(initialPosition.getIndex()),destination);
		
		//wrap the object
		
		this.route = new Route();
		wrapRoute(new Integer(nextCid).toString(),new Integer(nextMid).toString(),path);
		
		
	}
	catch (NamingException e) {
		//e.printStackTrace();
		System.out.println("Naming Exception Occured");
		//throw new RemoteException("Naming Exception Occured");
		throw new EJBException("Naming Exception Occured");
	} 
	catch (FinderException e) {
		//e.printStackTrace();
		System.out.println("Finder Exception Occured");
		throw new EJBException("Finder Exception Occured");
		//throw new RemoteException("Finder Exception Occured");
	}
	catch (CreateException e) {
		//e.printStackTrace();
		System.out.println("Create Exception Occured");
		throw new EJBException("Create Exception Occured");
	}
	catch (RemoteException e) {
		//e.printStackTrace();
		System.out.println("Remote Exception Occured");
		throw new EJBException("Remote Exception Occured");
	}

	
	wrapRoute(new Integer(nextCid).toString(),new Integer(nextMid).toString(),path);
	return route;
		

}

private RouteFinderHome getRouteFinderHome()
throws NamingException {
	return (analysis.gps.server.routeFinder.RouteFinderHome) getContext()
	.lookup(
			analysis.gps.server.routeFinder.RouteFinderHome.JNDI_NAME);
}
}